
function love.load()
	require "conf" -- Loads config.
	score = 0 -- Score
	
	snake = {} -- Head
	snake.s = 100 -- Speed
	snake.x = 100 -- X
	snake.y = 100 -- Y
	snake.w = 10 -- Width
	snake.h = 10 -- Height
	snake.l = {} -- Length, as in length of body
	
	snake.d = 3 -- Direction, like a clock, 12 = Up, 3 = Right, 6 = Down, 9 = Left
	snake.gx = 110 --
	snake.gy = 100 --
	
	gox = 1 -- Score's x position (Used for game over message with goy and gos aswell)
	goy = 24 -- Score's y position 
	gos = 1 -- Score's scale
	
	dot = {} -- Dots that the snake eats
	dot.b = true -- Dot.Boolean, turns false if player eats ball, turns true when spawned
	dot.x = 310 -- X
	dot.y = 100 -- Y
	dot.w = 10 -- Width
	dot.h = 10 -- Height
end

function love.keypressed(k) -- Movement function, doesn't move snake, but changes the direction
	if k == "right" then
		snake.d = 3
		elseif k == "left" then
			snake.d = 9
			elseif k == "down" then
				snake.d = 6
				elseif k == "up" then
					snake.d = 12
	end
end

function dotspawn() -- Dot spawning function.
--[[	After some reading, I realized the reason why math.random isn't that random at all, the "best random numbers"
		is apparently basing it off os.time().  When both the X and Y of Dot were using this math, it ended up giving me
		somewhat predictable numbers for some reason... Also for some reason, it kept giving me the same x axis but only 
		was changing the y value.  That is what lead me to giving the mathrandom to dot.x, and using that number as the
		math.randomseed for the dot.y variable.  This is to be dealt with later on.		]]--
	if dot.b == false then -- <--- Get's changed when dot is collision is detected.
		score = score + 1 -- <-- Adds one to the score.
		--math.randomseed(os.time())
		dot.x = math.random(5,485)
		--math.randomseed(dot.x)
		dot.y = math.random(5,485)
		dot.b = true -- <--- Changes dot.b value after spawning new dot.
	end
end

function love.update(dt)
--[[	Alright... I was hoping the next chunk of code would add a so called target.x for the snake's body(snake.l).  It
		didn't work like that though.  My idea would be that everytime the direction get's changed, a new target.x and
		target.y would be inserted into snake.l table, and thus; would give the additional pieces of the body a place to
		go to.  I just can't seem to wrap my head around the idea of how to properly execute this.		]]--
		if snake.d == 12 then
			snake.y = snake.y - snake.s*dt
			for i,v in ipairs(snake.l) do
				v.tx = snake.x
				v.ty = snake.y
			end
			elseif snake.d == 6 then
				snake.y = snake.y + snake.s*dt
				for i,v in ipairs(snake.l) do
					v.tx = snake.x
					v.ty = snake.y
				end
				elseif snake.d == 3 then
					snake.x = snake.x + snake.s*dt
					for i,v in ipairs(snake.l) do
						v.tx = snake.x
						v.ty = snake.y
					end
					elseif snake.d == 9 then
						snake.x = snake.x - snake.s*dt
						for i,v in ipairs(snake.l) do
							v.tx = snake.x
							v.ty = snake.y
						end
		end
		
		if CheckCollision(snake.x,snake.y,snake.w,snake.h,dot.x,dot.y,dot.w,dot.h) then -- Hardon collider
			dot.b = false -- <--- Set's dot.b to false
			snake.s = snake.s + 1 -- <--- Updates the speed of the snake.  I don't use score for debug purposes
--[[		Below is my attempt to adding additional bodies to the snake.		]]--
			--[[for i,v in ipairs (snake.l) do
				v.x = snake.x - 10
				v.y = snake.y - 10
			table.insert(snake.l, v.x)
			table.insert(snake.l, v.y)
			end]]--
			dotspawn() -- <--- Begins dotspawn()
		end

--[[	This is my attempt to move the snake bodies to it's target location.	]]--
		for i, v in ipairs(snake.l) do
			if v.d == 3 then
				if v.x < v.tx then
					v.x = v.x + snake.s*dt
				end
			elseif v.d == 9 then
				if v.x > v.tx then
					v.x = v.x - snake.s*dt
				end
			elseif v.d == 9 then
				if v.y < v.ty then
					v.y = v.y + snake.s*dt
				end
			elseif v.d == 12 then
				if v.y > v.ty then
					v.y = v.y - snake.s*dt
				end
			end
		end
		
--[[	Setting the boundries of the game.  Also triggers Game Over ]]--
		if snake.x <= 5 then
			snake.s = 0
			elseif snake.x+10 >= 495 then
				snake.s = 0
				elseif snake.y <= 5 then
					snake.s = 0
					elseif snake.y+10 >= 495 then
						snake.s = 0
		end

		if snake.s == 0 then -- <-- Increases GameOver X,Y, & Scale so it looks "cool" when you lose.  More lame than cool.
			if gos <= 7.55 then
				gox = gox+gox*dt*2
				goy = goy+goy*dt*2
				gos = gos+gos*dt*2
			end
		end		
end

function love.draw()
	love.graphics.setColor(175,0,175,255) -- Draw's the snake head.
		love.graphics.rectangle("fill",snake.x,snake.y,snake.w,snake.h)
	
	love.graphics.setColor(150,0,150,255) -- "Draws" the body...
	for i, v in ipairs (snake.l) do
		love.graphics.rectangle("fill",v.x,v.y,snake.w,snake.h)
	end
	
	love.graphics.setColor(255,0,0,255) -- Draws the border.
		love.graphics.setLine(5,"smooth")
		love.graphics.rectangle("line",1,1,500,500)
	
	if dot.b == true then -- Draws the dot.
		love.graphics.setColor(255,255,255,255)
		love.graphics.rectangle("fill",dot.x,dot.y,dot.w,dot.h)
	end
	
	if snake.s == 0 then -- <--- Game Over Message)
		love.graphics.setColor(255,255,255,255)		
		love.graphics.print("YOU LOSE!", gox,goy,0,gos,gos)
	end
	
	love.graphics.setColor(255,255,255,255) -- Draw's score.
	love.graphics.print("SCORE -  "..score,gox,goy+30,150)	
	
	-- ** DEBUG INFO ** --
	local dx = 505
	local dy = 12
	love.graphics.print("--DEBUG--",dx,0)
	love.graphics.print("snake.x - "..math.floor(snake.x),dx,dy)
	love.graphics.print("snake.y - "..math.floor(snake.y),dx,dy*2)
	love.graphics.print("snake.s - "..snake.s,dx,dy*3)
	love.graphics.print("snake.d - "..snake.d,dx,dy*4)
	love.graphics.print("dot.x - "..dot.x,dx,dy*5)
	love.graphics.print("dot.x - "..dot.y,dx,dy*6)
	love.graphics.print("Hey.......... It's a start!",dx+15,dy^2*2.5,1.55)
end

--[[	HardonCollider - Found at - http://love2d.org/wiki/HardonCollider]]--
function CheckCollision(box1x, box1y, box1w, box1h, box2x, box2y, box2w, box2h)
    if box1x > box2x + box2w - 1 or
       box1y > box2y + box2h - 1 or
       box2x > box1x + box1w - 1 or
       box2y > box1y + box1h - 1
    then
        return false
    else
        return true
    end
end

function love.keyreleased(escape) -- Quit's game
	if escape == "escape" then
		love.event.push('q')
	end
end